﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.9
@EndOfDesignText@
Sub Class_Globals
	Private bc As ByteConverter
	Private udpsock As UDPSocket
	Private host As String
	Private mac As List
	Private port As Int = 51042
	Private count As Int
	Private Server As ServerSocket
	
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(initHost As String, initMac As String, initPort As Int)
	host = initHost
	mac = SplitMac(initMac)
	count = Rnd(0, 0xffff)
	'udpsock.Initialize2("Udpsock", port, 8192, True, False)
	udpsock.Initialize("Udpsock",port,8192)
   	
End Sub
Public Sub mioIp As String
	Return	Server.GetMyIP
End Sub

Private  Sub GetBroadcastAddress As String
	Dim niIterator As JavaObject
	niIterator = niIterator.InitializeStatic("java.net.NetworkInterface").RunMethod("getNetworkInterfaces", Null)
	Do While niIterator.RunMethod("hasMoreElements", Null)
		Dim ni As JavaObject = niIterator.RunMethod("nextElement", Null)
		If ni.RunMethod("isLoopback", Null) = False Then
			Dim addresses As List = ni.RunMethod("getInterfaceAddresses", Null)
			For Each ia As JavaObject In addresses
				Dim broadcast As Object = ia.RunMethod("getBroadcast", Null)
				If broadcast <> Null Then
					Dim b As String = broadcast
					Return b.SubString(1)
				End If
			Next
		End If
	Loop
	Return ""
End Sub

Public Sub trasmetti(msg As String) As Int
	Dim Data()    As Byte
	Data = msg.GetBytes("UTF8")
	'Udpsock_SendPacket(packet)
	Udpsock_SendPacket(Data)
	Return 0
	
End Sub
Private Sub Udpsock_SendPacket(data() As Byte)
	Try
		Dim packet As UDPPacket
		packet.Initialize(data, host, port)
		udpsock.Send(packet)
		
	Catch
		Log("Udpsock_SendPacket: " & LastException)
	End Try
End Sub

Sub Udpsock_PacketArrived(receivedPacket As UDPPacket)
	
	 If receivedPacket.HostAddress <> mioIp Then
		Dim stringa As String =	BytesToString(receivedPacket.Data,0,receivedPacket.Length,"utf-8")
		Main.lblRicezione.Text=Main.lblRicezione.Text.Trim & CRLF  & stringa
	End If
	
	
	'Main.lblRicezione.Text=Main.lblRicezione.Text.Trim & CRLF  &host&" from host:"&receivedPacket.HostAddress
	Log("Udpsock_PacketArrived instance:"&host&" from host:"&receivedPacket.HostAddress)
End Sub

Private Sub SplitMac(theMac As String) As List

	Dim l As List
	Dim delim As String

	If theMac.Contains(".") Then
		delim = "."
	Else If theMac.Contains(":") Then
		delim = ":"
	Else
		Log("SplitMac: MAC address contains neither '.' nor ':' as separator between each pair of characters")
		Return Null
	End If

	l = Regex.Split(delim, theMac)
	If l.Size < 5 Then
		l.Add(0)
		l.Add(0)
	End If

	Return l

End Sub